import { Plus, RefreshCcw } from "lucide-react";
import Head from "next/head";
import { useState } from "react";
import toast from "react-hot-toast";
import { AreaRiservataLayout } from "~/components/Layout";
import { LoadingPage } from "~/components/loading";
import { Status500 } from "~/components/status-page";
import { BannersTable } from "~/components/tables/banners-table";
import { Button } from "~/components/ui/button";
import {
	Dialog,
	DialogContent,
	DialogDescription,
	DialogHeader,
	DialogTitle,
	DialogTrigger,
} from "~/components/ui/dialog";
import { FormBanners } from "~/forms/FormBanners";
import type { NextPageWithLayout } from "~/pages/_app";
import type { Banners } from "~/schemas/public/Banners";
import { generateSSGHelper } from "~/server/utils/ssgHelper";
import { api } from "~/utils/api";

/**
 * Pagina di gestione banners per admin: /area-riservata/admin/banners
 */
const AdminBanners: NextPageWithLayout = () => {
	const { data, isLoading, refetch } = api.banners.getBannerAllData.useQuery();
	const [openEdit, setOpenEdit] = useState(false);
	const [editData, setEditData] = useState<Banners | null>(null);

	const handleOpen = (status: boolean) => {
		setOpenEdit(status);
	};
	const handleEdit = (data: Banners | null) => {
		setEditData(data);
	};

	if (isLoading) return <LoadingPage />;
	if (!data) return <Status500 />;

	return (
		<>
			<Head>
				<title>Banners - Infoalloggi.it</title>
			</Head>
			<div className="mx-1 flex-1 overflow-auto">
				<div className="mx-auto pt-4">
					<div className="mx-auto items-start justify-between px-2 md:flex">
						<div className="flex items-center gap-3">
							<h3 className="font-bold text-accent-foreground text-xl sm:text-2xl">
								Banners
							</h3>
							<button
								className="cursor-pointer"
								onClick={async () => await refetch()}
								type="button"
							>
								<RefreshCcw className="size-6" />
							</button>
						</div>

						<div className="mt-3 md:mt-0">
							<EditModal
								initial={editData}
								open={openEdit}
								setOpen={handleOpen}
							/>
						</div>
						<div className="mt-3 md:mt-0">
							<Button
								className="font-semibold"
								onClick={() => {
									handleEdit(null);
									handleOpen(true);
								}}
								variant="outline"
							>
								<Plus className="size-6" />
								Nuovo
							</Button>
						</div>
					</div>

					<BannersTable
						data={data}
						setEditData={handleEdit}
						setOpenEdit={handleOpen}
					/>
				</div>
			</div>
		</>
	);
};
export default AdminBanners;
export async function getServerSideProps() {
	const helpers = generateSSGHelper();

	await helpers.banners.getBannerAllData.prefetch();

	return {
		props: {
			trpcState: helpers.dehydrate(),
		},
	};
}

AdminBanners.getLayout = function getLayout(page) {
	return <AreaRiservataLayout>{page}</AreaRiservataLayout>;
};

const EditModal = ({
	initial,
	open,
	setOpen,
}: {
	initial: Banners | null;
	open: boolean;
	setOpen: (status: boolean) => void;
}) => {
	const utils = api.useUtils();
	const { mutate: edit } = api.banners.updateBanner.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banners.getBannerAllData.invalidate();
			await utils.banners.getBannerData.invalidate();
			setOpen(false);
		},
	});
	const { mutate: add } = api.banners.addBanner.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banners.getBannerAllData.invalidate();
			await utils.banners.getBannerData.invalidate();
			setOpen(false);
		},
	});
	const { mutate: del } = api.banners.deleteBanner.useMutation({
		onError: (error) => {
			toast.error(error.message);
		},
		onSuccess: async () => {
			toast.success("Successo");
			await utils.banners.getBannerAllData.invalidate();
			await utils.banners.getBannerData.invalidate();
			setOpen(false);
		},
	});

	return (
		<Dialog onOpenChange={setOpen} open={open}>
			<DialogTrigger asChild />
			<DialogContent className="sm:max-w-106.25">
				<DialogHeader>
					<DialogTitle>
						{!initial ? "Aggiungi Banner" : "Modifica Valori"}
					</DialogTitle>
					<DialogDescription className="sr-only">Edit</DialogDescription>
				</DialogHeader>
				{!initial ? (
					<div className="py-4">
						<FormBanners
							initialValues={null}
							submitMutation={(fields) => {
								add({
									...fields,
								});
							}}
						/>
					</div>
				) : (
					<div className="py-4">
						<FormBanners
							del={(v) => del({ idbanner: v })}
							initialValues={{
								...initial,
							}}
							submitMutation={(fields) => {
								edit({
									...fields,
								});
							}}
						/>
					</div>
				)}
			</DialogContent>
		</Dialog>
	);
};
